# docker-compose file for local development and testing with container image.
#
# Extends compose/base.yml so launch services via:
#
#   docker-compose -f compose/base.yml -f compose/development.yml
version: '3.2'
services:

  # Main web application service
  development_app:
    build:
      context: ..
      dockerfile: ./compose/development.django.Dockerfile

    expose:
      - "8000"

    ports:
      - "8000:8000"

    env_file:
      - base.env
      - development.env
      - ../secrets.env

    depends_on:
      - "wls2oauth2-db"
    # Options stdin_open and tty are set to allow you to attach to the container for the purposes
    # of debugging.
    # See https://blog.lucasferreira.org/howto/2017/06/03/running-pdb-with-docker-and-gunicorn.html
    stdin_open: true
    tty: true

    # For development, mount the local directory inside the container as a
    # volume to allow local changes to be reflected without having to re-build
    # the container.
    volumes:
      - type: bind
        source: ../
        target: /usr/src/app
        read_only: true
      - type: volume
        source: pudb-config
        target: /root/.config/pudb

volumes:
  # A persistent volume to preserve the pudb configuration.
  pudb-config:
